"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DbConfigSourceBotstrapper = void 0;
/* eslint-disable @typescript-eslint/no-explicit-any */
/* eslint-disable @typescript-eslint/no-unsafe-argument */
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/require-await */
const di_1 = require("@spinajs/di");
const DbConfig_js_1 = require("./models/DbConfig.js");
const configuration_db_source_schema_js_1 = __importDefault(require("./schemas/configuration.db.source.schema.js"));
const configuration_common_1 = require("@spinajs/configuration-common");
const orm_1 = require("@spinajs/orm");
const lodash_1 = __importDefault(require("lodash"));
/**
 * watch interval, default 3 min
 */
const CONFIG_WATCH_TIMER_INTERVAL = 3 * 60 * 1000;
function __saveConfigOptions(v) {
    if (v.options.expose) {
        void DbConfig_js_1.DbConfig.insert({
            Slug: v.path,
            Value: v.options.defaultValue,
            Group: v.options.exposeOptions?.group,
            Label: v.options.exposeOptions?.label,
            Description: v.options.exposeOptions?.description,
            Meta: v.options.exposeOptions?.meta,
            Required: v.options.required,
            Type: v.options.exposeOptions?.type,
            Watch: v.options.exposeOptions?.watch ?? false,
            Default: v.options.defaultValue ?? undefined,
            Exposed: true,
        }, orm_1.InsertBehaviour.InsertOrIgnore);
    }
}
let DbConfigSourceBotstrapper = class DbConfigSourceBotstrapper extends di_1.Bootstrapper {
    async bootstrap() {
        di_1.DI.register(configuration_db_source_schema_js_1.default).asValue('__configurationSchema__');
        // register all conf options
        // as we go ( eg. resolved service )
        di_1.DI.on('di.registered.__configuration_property__', (v) => {
            if (v.options && v.options.expose) {
                __saveConfigOptions(v);
                void DbConfig_js_1.DbConfig.where("Slug", v.path).first().then((result) => {
                    const cService = di_1.DI.get(configuration_common_1.Configuration);
                    cService.set(v.path, result?.Value ?? v.options.defaultValue);
                });
            }
        });
        // register vals added before orm is resolved eg. at bostrap phase
        di_1.DI.once('di.resolved.Orm', (container) => {
            const vars = container
                .get(Array.ofType('__configuration_property__'))
                .filter((x) => x.options)
                .filter((x) => x.options.expose);
            /**
             * Insert to db all exposed config options
             */
            for (const v of vars) {
                __saveConfigOptions(v);
            }
            const interval = di_1.DI.get('__config_watch_interval__');
            const watchTimer = setInterval(() => {
                const varsToWatch = vars.filter((x) => x.options.exposeOptions.watch);
                const cService = container.get(configuration_common_1.Configuration);
                if (varsToWatch.length === 0) {
                    return;
                }
                void DbConfig_js_1.DbConfig.query()
                    .whereIn('Slug', varsToWatch.map((x) => x.path))
                    .then((result) => {
                    result.forEach((r) => {
                        const cfgVal = cService.get(`${r.Group}.${r.Slug}`);
                        if (!lodash_1.default.isEqual(cfgVal, r.Value)) {
                            cService.set(`${r.Group}.${r.Slug}`, r.Value);
                        }
                    });
                    return;
                });
            }, interval?.value || CONFIG_WATCH_TIMER_INTERVAL);
            di_1.DI.once('di.dispose', () => {
                clearInterval(watchTimer);
            });
        });
        return;
    }
};
exports.DbConfigSourceBotstrapper = DbConfigSourceBotstrapper;
exports.DbConfigSourceBotstrapper = DbConfigSourceBotstrapper = __decorate([
    (0, di_1.Injectable)(di_1.Bootstrapper)
], DbConfigSourceBotstrapper);
//# sourceMappingURL=bootstrap.js.map