import { DateTime } from 'luxon';
export interface IConfiguratioDbSourceConfig {
    connection: string;
    table: string;
}
export type ConfigurationEntryType = 'int' | 'float' | 'string' | 'json' | 'date' | 'datetime' | 'time' | 'boolean' | 'time-range' | 'date-range' | 'datetime-range' | 'range' | 'oneOf' | 'manyOf' | 'file';
export interface IConfigurationEntry {
    Id: number;
    Slug: string;
    Value: any;
    Group: string;
    Type: ConfigurationEntryType;
}
export interface IConfigurationEntryMeta {
    minDate?: DateTime;
    maxDate?: DateTime;
    min?: number;
    max?: number;
    oneOf?: string[];
    manyOf?: string[];
}
declare module '@spinajs/configuration-common' {
    interface IConfigEntryOptions {
        /**
         * Should value be exposed in db
         */
        expose?: boolean;
        /**
         * DB expose options
         */
        exposeOptions?: {
            slug?: string;
            group?: string;
            type: ConfigurationEntryType;
            meta?: IConfigurationEntryMeta;
            description?: string;
            label?: string;
            /**
             * Should we watch for config val change
             * Usefull if we dont need to restart app when value changes
             */
            watch?: boolean;
        };
    }
}
//# sourceMappingURL=types.d.ts.map