var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
/* eslint-disable @typescript-eslint/no-unused-vars */
import { OrmMigration, Migration } from '@spinajs/orm';
let configuration_db_source_2022_02_08_01_13_00 = class configuration_db_source_2022_02_08_01_13_00 extends OrmMigration {
    async up(connection) {
        await connection.schema().createTable('configuration', (table) => {
            table.int('Id').primaryKey().autoIncrement();
            table.string('Slug', 64).notNull();
            table.text('Value');
            table.text('Default');
            table.boolean('Required').default().value(0);
            table.boolean('Exposed').notNull().default().value(0);
            table.boolean('Watch').notNull().default().value(0);
            table.string('Group', 32);
            table.string('Label', 64);
            table.string('Description', 256);
            table.string('Environment', 32);
            table.text('Meta');
            table.enum('Type', ['int', 'file', 'float', 'string', 'json', 'date', 'datetime', 'time', 'boolean', 'time-range', 'date-range', 'datetime-range', 'range', 'oneOf', 'manyOf']).notNull();
        });
        await connection.index().unique().table('configuration').name('configuration_unique_slug').columns(['Slug']);
    }
    // tslint:disable-next-line: no-empty
    async down(_connection) {
        //_connection.schema().dropTable('configuration');
    }
};
configuration_db_source_2022_02_08_01_13_00 = __decorate([
    Migration('default')
], configuration_db_source_2022_02_08_01_13_00);
export { configuration_db_source_2022_02_08_01_13_00 };
//# sourceMappingURL=configuration_db_source_2022_02_08_01_13_00.js.map