var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
/* eslint-disable @typescript-eslint/no-unused-vars */
/* eslint-disable @typescript-eslint/no-explicit-any */
/* eslint-disable @typescript-eslint/no-unsafe-return */
/* eslint-disable @typescript-eslint/restrict-template-expressions */
/* eslint-disable prettier/prettier */
import { Connection, Primary, Model, ModelBase } from '@spinajs/orm';
import _ from 'lodash';
import { DateTime } from 'luxon';
let DbConfig = class DbConfig extends ModelBase {
    hydrate(data) {
        Object.assign(this, {
            ...data,
            Value: parse(data.Value, data.Type),
            Default: parse(data.Value, data.Type)
        });
    }
    dehydrate(_omit) {
        return {
            ...this,
            Value: this.stringify(this.Value),
            Default: this.stringify(this.Default)
        };
    }
    stringify(val) {
        if (val instanceof DateTime) {
            switch (this.Type) {
                case 'date':
                    return val.toFormat('dd-MM-yyyy');
                case 'time':
                    return val.toFormat('HH:mm:ss');
                case 'datetime':
                    return val.toISO();
            }
        }
        if (_.isArray(val)) {
            switch (this.Type) {
                case 'date-range':
                    return val.map((x) => x.toFormat('dd-MM-yyyy')).join(';');
                case 'time-range':
                    return val.map((x) => x.toFormat('HH:mm:ss')).join(';');
                case 'datetime-range':
                    return val.map((x) => x.toISO()).join(';');
            }
        }
        if (this.Type === 'manyOf') {
            return JSON.stringify(val);
        }
        if (_.isString(val) || _.isNumber(val) || _.isBoolean(val)) {
            return `${val}`;
        }
        return JSON.stringify(val);
    }
};
__decorate([
    Primary(),
    __metadata("design:type", Number)
], DbConfig.prototype, "Id", void 0);
DbConfig = __decorate([
    Connection('default'),
    Model('configuration')
], DbConfig);
export { DbConfig };
export function parse(input, type) {
    switch (type) {
        case 'string':
        case 'file':
        case 'oneOf':
            return input;
        case 'int':
        case 'float':
        case 'range':
            return Number(input);
        case 'boolean':
            return input === '1' ? true : false;
        case 'datetime':
            return DateTime.fromISO(input);
        case 'time':
            return DateTime.fromFormat(input, 'HH:mm:ss');
        case 'date':
            return DateTime.fromFormat(input, 'dd-MM-yyyy');
        case 'datetime-range':
            return input.split(';').map((x) => DateTime.fromISO(x));
        case 'time-range':
            return input.split(';').map((x) => DateTime.fromFormat(x, 'HH:mm:ss'));
        case 'date-range':
            return input.split(';').map((x) => DateTime.fromFormat(x, 'dd-MM-yyyy'));
        default:
            return JSON.parse(input);
    }
}
//# sourceMappingURL=DbConfig.js.map